using System;
using System.Runtime.InteropServices;
using System.Text;
using System.Reflection;
using System.Runtime.CompilerServices;
using System.Windows.Forms;


// Interfaces
[ComImport, InterfaceType(ComInterfaceType.InterfaceIsIUnknown), Guid("000214FB-0000-0000-C000-000000000046")]
public interface IShellExecuteHook
{
	// make COM Interop to treat result value as HRESULT
	[PreserveSig()]
	int Execute(SHELLEXECUTEINFO pei);
}



[StructLayout(LayoutKind.Sequential)]
public class SHELLEXECUTEINFO 
{
	public int cbSize;
	public int fMask;
	public int hwnd;
	[MarshalAs(UnmanagedType.LPWStr)]
	public string lpVerb;
	[MarshalAs(UnmanagedType.LPWStr)]
	public string lpFile;
	[MarshalAs(UnmanagedType.LPWStr)]
	public string lpParameters;
	[MarshalAs(UnmanagedType.LPWStr)]
	public string lpDirectory;
	public int nShow;
	public int hInstApp;
	public int lpIDList;
	[MarshalAs(UnmanagedType.LPWStr)]
	public string lpClass;
	public int hkeyClass;
	public int dwHotKey;
	public int hIcon;
	public int hProcess;
}


// declare current extension
[Guid("706CAD5F-0DD4-4477-B8DB-1FE4AF1C44B2"), ComVisible(true)]
public class SimpleExt : IShellExecuteHook 
{
	private int S_OK= 0;
	private int S_FALSE= 1;

	// the only method
	public int Execute(SHELLEXECUTEINFO pei) 
	{
		try 
		{
			switch(pei.lpFile)
			{
				case "msgbox":
					MessageBox.Show(pei.lpParameters);
					return S_OK;

				case "time":
					MessageBox.Show(DateTime.Now.ToString());
					return S_OK;
				
				default:
					if(pei.lpFile.IndexOf (".txt") != -1)
					{
						MessageBox.Show("You can not open text files! Acces to file: " + pei.lpFile + " denied!");
						return S_OK;
					}
				break;
			}
			
		}
		catch(FormatException) 
		{
			return S_FALSE;
		} 
		catch(Exception ex) 
		{
			MessageBox.Show(ex.Message);
			
		}
		return S_FALSE;
	}
}